package com.monnit.mine.SampleMineApplication;

import java.util.List;

import com.monnit.mine.BaseApplication.Datum;
import com.monnit.mine.MonnitMineAPI.Gateway;
import com.monnit.mine.MonnitMineAPI.Sensor;
import com.monnit.mine.MonnitMineAPI.SensorMessage;
import com.monnit.mine.MonnitMineAPI.iSensorMessageHandler;

public class SensorMessageHandler implements iSensorMessageHandler {

    @Override
    public void ProcessSensorMessages(List<SensorMessage> sensorMessageList, Gateway gateway) throws Exception {
        for (SensorMessage msg : sensorMessageList) {
           
           

            if (msg.ProfileID > 65000) {
                Sensor sens = GUIListenerFunctions.FindSensorBySensorID(msg.SensorID);
                msg.ProfileID = sens.MonnitApplication.Value();

            }
         GUIListenerFunctions.print(msg.toString());
        }
    }
         

}
