/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.monnit.mine.SampleMineApplication;

import com.monnit.mine.MonnitMineAPI.Sensor;
import com.monnit.mine.BaseApplication.applicationclasses.AnalogBase;
import com.monnit.mine.BaseApplication.applicationclasses.ResistanceBase;
import com.monnit.mine.BaseApplication.applicationclasses.ResistanceDeltaBase;
import com.monnit.mine.BaseApplication.applicationclasses.TemperatureBase;
import com.monnit.mine.BaseApplication.applicationclasses.WaterTemperatureBase;

/**
 *
 * @author MonnitDev
 */
public class UpdateSensor {

    public static void updateTempSensor(int sid)
            throws Exception {
        try {
            Sensor sens = GUIListenerFunctions.FindSensorBySensorID(sid);

            int monnitappID = (int) sens.MonnitApplication.Value();
            switch (monnitappID) {
                case 1:
                    AnalogBase.SensorEdit(sens, getHeartbeat(), getHeartbeat(), null, null, null, null, null, null, null);
                    break;
                case 2:
                    TemperatureBase.SensorEdit(sens, getHeartbeat(), getAwareStateHeartbeat(), getAssessmentsPerHeartbeat(), getMinimumThreshold(), 
                            getMaximumThreshold(), getHysteresis(), getFailedTransmissionsBeforeLinkMode());
                    break;
                case 65:
                    WaterTemperatureBase.SensorEdit(sens, getHeartbeat(), getAwareStateHeartbeat(), getAssessmentsPerHeartbeat(), getMinimumThreshold(),
                            getMaximumThreshold(), getHysteresis(), getFailedTransmissionsBeforeLinkMode());
                    break;
                case 99:
                    ResistanceDeltaBase.SensorEdit(sens, getHeartbeat(), getHeartbeat(), null, null, null, null, null);
                    break;
                case 3:
                case 4:
                case 5:
                case 9:
                case 11:
                case 12:
                case 13:
                case 14:
                case 19:
                case 21:
                case 22:
                case 23:
                case 26:
                case 27:
                case 28:
                case 34:
                case 35:
                case 36:
                case 42:
                case 43:
                case 45:
                case 46:
                case 48:
                case 51:
                case 59:
                case 60:
                case 66:
                case 68:
                case 70:
//                    ResistanceBase.SensorEdit(sens, getHeartbeat(), getHeartbeat(), null, null, null, null, null);
                    break;
                case 71:
                case 72:
                case 73:
                case 74:
                case 75:
                case 79:
                case 81:
                case 82:
                case 83:
                case 84:
                case 85:
                case 89:
                case 90:
                case 93:
                case 94:
                case 95:
                default:
               throw new Exception("Update Not Implemented for " + sens.MonnitApplication.toString());
            }

        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    private static double getHeartbeat() {
        try {
            return Double.parseDouble(UpdateTemperatureSensor.heartBeatText.getText());
        } catch (Exception e) {
            return -1;
        }
    }
    
    private static double getAwareStateHeartbeat() {
        try {
            return Double.parseDouble(UpdateTemperatureSensor.awareStateHeartBeatText.getText());
        } catch (Exception e) {
            return -1;
        }
    }
    
    private static int getAssessmentsPerHeartbeat() {
        try {
            return Integer.parseInt(UpdateTemperatureSensor.assessmentsPerHeartBeatText.getText());
        } catch (Exception e) {
            return -1;
        }
    }
    
    private static double getMinimumThreshold() {
        try {
            return Double.parseDouble(UpdateTemperatureSensor.minimumThresholdText.getText());
        } catch (Exception e) {
            return 0;
        }
    }
    
    private static double getMaximumThreshold() {
        try {
            return Double.parseDouble(UpdateTemperatureSensor.maximumThresholdText.getText());
        } catch (Exception e) {
            return 0;
        }
    }
    
    private static double getHysteresis() {
        try {
            return Double.parseDouble(UpdateTemperatureSensor.HysteresisText.getText());
        } catch (Exception e) {
            return -1;
        }
    }
    
    private static int getFailedTransmissionsBeforeLinkMode() {
        try {
            return Integer.parseInt(UpdateTemperatureSensor.failedLinkModeText.getText());
        } catch (Exception e) {
            return -1;
        }
    }
}
