/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.monnit.mine.SampleMineApplication;

import com.monnit.mine.BaseApplication.ExtensionMethods.Extensions;
import static com.monnit.mine.EventHandling.GatewayResponseHandler._Server;
import com.monnit.mine.MonnitMineAPI.Sensor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.*;
import java.awt.*;

/**
 *
 * @author MonnitDev
 */
public class UpdateTemperatureSensor {

    public static JFrame frame;
    public static JPanel panel;
    public static JPanel SensPanel;
    public static JButton close;
    public static JButton update;
    
    public static JPanel heartBeatPanel;
    public static JLabel heartBeatLabel;
    public static JTextField heartBeatText;
    
    public static JPanel awareStateHeartBeatPanel;
    public static JLabel awareStateHeartBeatLabel;
    public static JTextField awareStateHeartBeatText;
    
    public static JPanel assessmentsPerHeartBeatPanel;
    public static JLabel assessmentsPerHeartBeatLabel;
    public static JTextField assessmentsPerHeartBeatText;
    
    public static JPanel minimumThresholdPanel;
    public static JLabel minimumThresholdLabel;
    public static JTextField minimumThresholdText;
    
    public static JPanel maximumThresholdPanel;
    public static JLabel maximumThresholdLabel;
    public static JTextField maximumThresholdText;
    
    public static JPanel HysteresisPanel;
    public static JLabel HysteresisLabel;
    public static JTextField HysteresisText;
    
    public static JPanel failedLinkModePanel;
    public static JLabel failedLinkModeLabel;
    public static JTextField failedLinkModeText;

    public static Dimension panelDimension = new Dimension(640, 700);
    public static Dimension gsDim = new Dimension(150, 10);

    public UpdateTemperatureSensor() {
        create();
    }

    public static void create() {
        frame = new JFrame("Temperature Update");
        frame.setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);

        panel = new JPanel(new BorderLayout());
        panel.setPreferredSize(panelDimension);
        frame.add(panel);

        createSens();

        panel.add(SensPanel, BorderLayout.CENTER);
        frame.pack();
        frame.setVisible(true);
    }

    private static void createSens() {
        SensPanel = new JPanel();
        SensPanel.setLayout(new BoxLayout(SensPanel, BoxLayout.Y_AXIS));
        SensPanel.setPreferredSize(gsDim);

        //<editor-fold defaultstate="collapsed" desc="HeartBeat">
        heartBeatPanel = new JPanel();
        heartBeatPanel.setLayout(new BoxLayout(heartBeatPanel, BoxLayout.X_AXIS));
        heartBeatLabel = new JLabel("Heartbeat");
        heartBeatText  = new JTextField();
        heartBeatText.setMaximumSize(new Dimension(100, 25));
        heartBeatText.setMinimumSize(new Dimension(1, 1));
        heartBeatText.setPreferredSize(new Dimension(4, 4));

        Dimension minSize = new Dimension(1, 1);
        Dimension prefSize = new Dimension(4, 4);
        Dimension maxSize = new Dimension(50, 50);
        heartBeatPanel.add(heartBeatLabel);
        heartBeatPanel.add(new Box.Filler(minSize, prefSize, maxSize));
        heartBeatPanel.add(heartBeatText);
//</editor-fold>

        //<editor-fold defaultstate="collapsed" desc="AwareStateHeartBeat">
        awareStateHeartBeatPanel = new JPanel();
        awareStateHeartBeatPanel.setLayout(new BoxLayout(awareStateHeartBeatPanel, BoxLayout.X_AXIS));
        awareStateHeartBeatLabel = new JLabel("Aware State Heartbeat");
        awareStateHeartBeatText  = new JTextField();
        awareStateHeartBeatText.setMaximumSize(new Dimension(100, 25));
        awareStateHeartBeatText.setMinimumSize(new Dimension(1, 1));
        awareStateHeartBeatText.setPreferredSize(new Dimension(4, 4));

        Dimension ashbMinSize = new Dimension(1, 1);
        Dimension ashbPrefSize = new Dimension(4, 4);
        Dimension ashbMaxSize = new Dimension(50, 50);
        awareStateHeartBeatPanel.add(awareStateHeartBeatLabel);
        awareStateHeartBeatPanel.add(new Box.Filler(ashbMinSize, ashbPrefSize, ashbMaxSize));
        awareStateHeartBeatPanel.add(awareStateHeartBeatText);
//</editor-fold>

        //<editor-fold defaultstate="collapsed" desc="AssessmentsPerHeartBeat">
        assessmentsPerHeartBeatPanel = new JPanel();
        assessmentsPerHeartBeatPanel.setLayout(new BoxLayout(assessmentsPerHeartBeatPanel, BoxLayout.X_AXIS));
        assessmentsPerHeartBeatLabel = new JLabel("Assessments Heartbeat");
        assessmentsPerHeartBeatText  = new JTextField();
        assessmentsPerHeartBeatText.setMaximumSize(new Dimension(100, 25));
        assessmentsPerHeartBeatText.setMinimumSize(new Dimension(1, 1));
        assessmentsPerHeartBeatText.setPreferredSize(new Dimension(4, 4));

        Dimension ahbMinSize = new Dimension(1, 1);
        Dimension ahbPrefSize = new Dimension(4, 4);
        Dimension ahbMaxSize = new Dimension(50, 50);
        assessmentsPerHeartBeatPanel.add(assessmentsPerHeartBeatLabel);
        assessmentsPerHeartBeatPanel.add(new Box.Filler(ahbMinSize, ahbPrefSize, ahbMaxSize));
        assessmentsPerHeartBeatPanel.add(assessmentsPerHeartBeatText);
//</editor-fold>

        //<editor-fold defaultstate="collapsed" desc="MinimumThreshold">
        minimumThresholdPanel = new JPanel();
        minimumThresholdPanel.setLayout(new BoxLayout(minimumThresholdPanel, BoxLayout.X_AXIS));
        minimumThresholdLabel = new JLabel("Minimum Threshold");
        minimumThresholdText  = new JTextField();
        minimumThresholdText.setMaximumSize(new Dimension(100, 25));
        minimumThresholdText.setMinimumSize(new Dimension(1, 1));
        minimumThresholdText.setPreferredSize(new Dimension(4, 4));

        Dimension minThreshMinSize = new Dimension(1, 1);
        Dimension minThreshPrefSize = new Dimension(4, 4);
        Dimension minThreshMaxSize = new Dimension(50, 50);
        minimumThresholdPanel.add(minimumThresholdLabel);
        minimumThresholdPanel.add(new Box.Filler(minThreshMinSize, minThreshPrefSize, minThreshMaxSize));
        minimumThresholdPanel.add(minimumThresholdText);
//</editor-fold>

        //<editor-fold defaultstate="collapsed" desc="MaximumThreshold">
        maximumThresholdPanel = new JPanel();
        maximumThresholdPanel.setLayout(new BoxLayout(maximumThresholdPanel, BoxLayout.X_AXIS));
        maximumThresholdLabel = new JLabel("Maximum Threshold");
        maximumThresholdText  = new JTextField();
        maximumThresholdText.setMaximumSize(new Dimension(100, 25));
        maximumThresholdText.setMinimumSize(new Dimension(1, 1));
        maximumThresholdText.setPreferredSize(new Dimension(4, 4));

        Dimension maxThreshMinSize = new Dimension(1, 1);
        Dimension maxThreshPrefSize = new Dimension(4, 4);
        Dimension maxThreshMaxSize = new Dimension(50, 50);
        maximumThresholdPanel.add(maximumThresholdLabel);
        maximumThresholdPanel.add(new Box.Filler(maxThreshMinSize, maxThreshPrefSize, maxThreshMaxSize));
        maximumThresholdPanel.add(maximumThresholdText);
//</editor-fold>

        //<editor-fold defaultstate="collapsed" desc="Hysteresis">
        HysteresisPanel = new JPanel();
        HysteresisPanel.setLayout(new BoxLayout(HysteresisPanel, BoxLayout.X_AXIS));
        HysteresisLabel = new JLabel("Hysteresis");
        HysteresisText  = new JTextField();
        HysteresisText.setMaximumSize(new Dimension(100, 25));
        HysteresisText.setMinimumSize(new Dimension(1, 1));
        HysteresisText.setPreferredSize(new Dimension(4, 4));

        Dimension HysteresisMinSize = new Dimension(1, 1);
        Dimension HysteresisPrefSize = new Dimension(4, 4);
        Dimension HysteresisMaxSize = new Dimension(50, 50);
        HysteresisPanel.add(HysteresisLabel);
        HysteresisPanel.add(new Box.Filler(HysteresisMinSize, HysteresisPrefSize, HysteresisMaxSize));
        HysteresisPanel.add(HysteresisText);
//</editor-fold>

        //<editor-fold defaultstate="collapsed" desc="FailedTransmissionsBeforeLinkMode">
        failedLinkModePanel = new JPanel();
        failedLinkModePanel.setLayout(new BoxLayout(failedLinkModePanel, BoxLayout.X_AXIS));
        failedLinkModeLabel = new JLabel("Failed Transmissions Before Link Mode");
        failedLinkModeText  = new JTextField();
        failedLinkModeText.setMaximumSize(new Dimension(100, 25));
        failedLinkModeText.setMinimumSize(new Dimension(1, 1));
        failedLinkModeText.setPreferredSize(new Dimension(4, 4));

        Dimension failedLinkModeMinSize = new Dimension(1, 1);
        Dimension failedLinkModePrefSize = new Dimension(4, 4);
        Dimension failedLinkModeMaxSize = new Dimension(50, 50);
        failedLinkModePanel.add(failedLinkModeLabel);
        failedLinkModePanel.add(new Box.Filler(failedLinkModeMinSize, failedLinkModePrefSize, failedLinkModeMaxSize));
        failedLinkModePanel.add(failedLinkModeText);
//</editor-fold>
        
        update = new JButton("Update");
        update.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                try {
                    UpdateSensor.updateTempSensor(GUIListenerFunctions.getSid());

                } catch (Exception e1) {
                    e1.printStackTrace();
                }
            }
        });
        
        close = new JButton("Close");
        close.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                try {

                    frame.setVisible(false);
                } catch (Exception e1) {
                    e1.printStackTrace();
                }
            }});
        
        SensPanel.add(heartBeatPanel);
        SensPanel.add(awareStateHeartBeatPanel);
        SensPanel.add(minimumThresholdPanel);
        SensPanel.add(maximumThresholdPanel);
        SensPanel.add(HysteresisPanel);
        SensPanel.add(failedLinkModePanel);
        
        SensPanel.add(new Box.Filler(minSize, prefSize, maxSize));
        SensPanel.add(update);
        
        SensPanel.add(new Box.Filler(minSize, prefSize, maxSize));
        SensPanel.add(close);
        
        int sensorID = GUIListenerFunctions.getSid();
        Sensor sens = null;
        if (sensorID > 0) {
            try {
                sens = _Server.FindSensor(sensorID);
            } catch (InterruptedException ex) {
                Extensions.debug("UpdateTemperatureSensor createSens() " + ex.toString());
            }
            
            heartBeatText.setText(String.valueOf(sens.getReportInterval()));
            awareStateHeartBeatText.setText(String.valueOf(sens.getActiveStateInterval()));
            assessmentsPerHeartBeatText.setText(String.valueOf(sens.getMeasurementsPerTransmission()));
            minimumThresholdText.setText(String.valueOf(sens.getMinimumThreshold()));
            maximumThresholdText.setText(String.valueOf(sens.getMaximumThreshold()));
            HysteresisText.setText(String.valueOf(sens.getHysteresis()));
            failedLinkModeText.setText(String.valueOf(sens.getRecovery()));
        }
    }
}